#include <stdio.h>
#include <stdlib.h>
#include <string.h>

char field[9][9];
int empty[81][2];
int block[9][2] = {
    { 1, 2 }, { 0, 2 }, { 0, 1 },
    { 4, 5 }, { 3, 5 }, { 3, 4 },
    { 7, 8 }, { 6, 8 }, { 6, 7 },
};

void print_field();
void brute_force( signed int emptyc );

int main( int argc, char *argv[] ) {
    if ( argc < 2 ) {
        printf( "No Puzzle found.\n" );
        return 1;
    }
    if ( strlen(argv[1]) != 81 ) {
        printf( "Puzzle must have 81 characters\n" );
        return 1;
    }

    int x, y;
    signed int emptyc = -1;
    for ( x = 0; x < 9; x++ ) {
        for ( y = 0; y < 9; y++ ) {
            field[y][x] = argv[1][x + y * 9];
            if ( field[y][x] == '.' ) {
                empty[++emptyc][0] = x;
                empty[  emptyc][1] = y;
            }
        }
    }

    print_field();
    brute_force( emptyc );
    return 0;
}

void brute_force ( signed int emptyc ) {
    int i;
    if ( emptyc == -1 ) {
        print_field();
        return;
    }
    int x = empty[emptyc][0];
    int y = empty[emptyc][1];
    int candidates[10] = { 1,1,1,1,1,1,1,1,1,1 };
    for ( i = 0; i < 9; i++ ) {
        if ( field[y][i] != '.' )
            candidates[ field[y][i] - 48 ] = 0;
    }
    for ( i = 0; i < 9; i++ ) {
        if ( field[i][x] != '.' )
            candidates[ field[i][x] - 48 ] = 0;
    }
    if ( field[block[y][0]][block[x][0]] != '.' ) 
        candidates[ field[block[y][0]][block[x][0]] - 48 ] = 0;
    if ( field[block[y][0]][block[x][1]] != '.' ) 
        candidates[ field[block[y][0]][block[x][1]] - 48 ] = 0;
    if ( field[block[y][1]][block[x][0]] != '.' ) 
        candidates[ field[block[y][1]][block[x][0]] - 48 ] = 0;
    if ( field[block[y][1]][block[x][1]] != '.' ) 
        candidates[ field[block[y][1]][block[x][1]] - 48 ] = 0;
    for ( i = 1; i <= 9; i++ ) {
        if ( candidates[i] == 1 ) {
            char s[10];
            sprintf( s, "%i", i );
            field[y][x] = s[0];
            brute_force( emptyc - 1 );
        }
    }
    field[y][x] = '.';
}

void print_field () {
    int x, y;
    for ( y = 0; y < 9; y++ ) {
        for ( x = 0; x < 9; x++ ) {
            printf( "%c ", field[y][x] );
        }
        printf( "\n" );
    }
    printf( "\n" );
}
