import std.stdio;

int[][] block = [ 
    [ 1, 2 ], [ 0, 2 ], [ 0, 1 ],
    [ 4, 5 ], [ 3, 5 ], [ 3, 4 ],
    [ 7, 8 ], [ 6, 8 ], [ 6, 7 ],
];
char[9][9] fieldr, fieldc;

void main( char[][] args ) {
    if ( (args.length != 2) || (args[1].length != 81) ) {
        writefln( "Fehlerhaftes Feld!" );
        return 0;
    }
    int[2][] empty;
    for (int x = 0; x <= 8; x++ ) { 
        fieldr[x][0..9] = args[1][x*9..x*9+9]; 
        for (int y = 0; y <= 8; y++) {
            fieldc[y][x] = fieldr[x][y];
            if ( fieldr[x][y] == '.' ) { 
                empty ~= [x,y]; 
            }
        }
    }
    print_field( fieldr );
    writefln();
    brute_force( empty );
}

void brute_force ( int[2][] empty ) {
    if ( empty.length <= 0 ) { print_field( fieldr ); return; }
    int x = empty[0][0];
    int y = empty[0][1];
    int[char] candidates;
    candidates = [ 
        '1': 1, '2': 1, '3': 1, '4': 1, '5': 1, '6': 1, '7': 1, '8': 1, '9': 1
    ];
    foreach ( num; fieldc[x] ) candidates[num] = 0;
    foreach ( num; fieldr[y] ) candidates[num] = 0;
    candidates[ fieldr[block[y][0]][block[x][0]] ] = 0;
    candidates[ fieldr[block[y][0]][block[x][1]] ] = 0;
    candidates[ fieldr[block[y][1]][block[x][0]] ] = 0;
    candidates[ fieldr[block[y][1]][block[x][1]] ] = 0;
    foreach ( num; candidates.keys ) {
        if ( candidates[num] == 1 ) {
            fieldc[x][y] = fieldr[y][x] = num;
            brute_force( empty[1 .. $] );
        }
    }
    fieldc[x][y] = fieldr[y][x] = '.';
}

void print_field ( char[9][9] field ) {
    foreach ( row; field ) { 
        foreach ( square; row ) writef( "%s ", square );
        writefln();
    }
}

