#!perl

use strict;
use warnings;

my $fieldstring = $ARGV[0];
if ( ! $fieldstring or $fieldstring !~ /^[\d.]{81}$/ ) {
    die 'Fehlerhaftes Feld!';
}

my @block = (
    [ 1, 2 ], [ 0, 2 ], [ 0, 1 ],
    [ 4, 5 ], [ 3, 5 ], [ 3, 4 ],
    [ 7, 8 ], [ 6, 8 ], [ 6, 7 ],
);
my @fieldr = map{ [ split //, $_ ] } $fieldstring =~ /(.{9})/g;
print join(' ',@$_) . "\n" for @fieldr;
my @fieldc = map{ my $x = $_; [ map{ $fieldr[$_]->[$x] } 0 .. 8 ] } 0 .. 8;
my @empty = 
    map{ @$_ } 
    sort{ @$a <=> @$b } 
    map{ 
        my $y = $_;
        [ map{ [ $_, $y ] }grep{ $fieldr[$y]->[$_] eq '.' } 0..8 ]
    } 0..8;
my %candidates;
brute_force( @empty );

sub brute_force {
    unless ( @_ ) { print_solved(); return; }
    my( $x, $y ) = @{ shift() };
    @candidates{ 
        1,2,3,4,5,6,7,8,9,
        @{ $fieldr[$y] }, 
        @{ $fieldc[$x] },
        @{ $fieldr[$block[$y]->[0]] }[@{ $block[$x] }],
        @{ $fieldr[$block[$y]->[1]] }[@{ $block[$x] }],
    } = (1,1,1,1,1,1,1,1,1, 0,0,0,0,0, 0,0,0,0,0, 0,0,0,0,0, 0,0,0,0,0,);
    for ( grep{ $candidates{$_} } keys %candidates ) {
        $fieldc[$x]->[$y] = $fieldr[$y]->[$x] = $_;
        brute_force( @_ );
    }
    $fieldc[$x]->[$y] = $fieldr[$y]->[$x] = '.';
}

sub print_solved {
    print "\n";
    print join( ' ', @$_ ) . "\n" for @fieldr;
    print "\n";
}
